local Tablet = AceLibrary("Tablet-2.0")
Click2Cast = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")

Click2Cast.version = "r" .. string.sub("$Revision: 1 $", 12, -3)
Click2Cast.date = string.sub("$Date: 2006-12-24 04:03:00 +0200 (Sun, 22 Oct 2006) $", 8, 17)
Click2Cast.hasIcon = "Interface\\CURSOR\\Cast"
Click2Cast.defaultPosition = 'RIGHT'
Click2Cast.hideWithoutStandby = true
Click2Cast.independentProfile = true
Click2Cast.actionText = {["macro"] = true,["spell"] = true}

function Click2Cast:OnInitialize()
	Click2Cast:RegisterDB("Click2CastDB")
	Click2Cast:RegisterDefaults('profile', {   
        clickOptions = {
            ['*'] = { action = "none" },
            ["BUTTON1"] = { action = "target" },
            ["BUTTON2"] = { action = "menu" },
        }
    })
	Click2Cast:CreateMenu()
end

function Click2Cast:OnEnable()
	if not ClickCastFrames then
		ClickCastFrames = {}
	end
	self.clickFrames = ClickCastFrames
	ClickCastFrames[PlayerFrame] = true
	ClickCastFrames[TargetFrame] = true
	setmetatable(self.clickFrames, { __newindex = function(self,k,v)
		if v == nil then
			Click2Cast:UnregisterFrame(k)
		else
			Click2Cast:RegisterFrame(k)
		end
		rawset(self, k, v)
	end })
	self:EnableFrames()
end

function Click2Cast:OnProfileEnable()
	self:EnableFrames()
end

function Click2Cast:EnableFrames()
	for frame in pairs(self.clickFrames) do
		self:RegisterFrame(frame)
	end
end

function Click2Cast:OnDisable()
	for frame in pairs(self.clickFrames) do
		self:UnregisterFrame(frame)
	end   
end

function Click2Cast:RegisterFrame(frame)
	frame:RegisterForClicks("LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up")
	for k,v in pairs(self.db.profile.clickOptions) do
		local button = k:match("(%d+)")
		local modifier = k:gsub("BUTTON%d", "")
		
		if self.actionText[v.action] then
			frame:SetAttribute(modifier .. "type" .. button, v.action)
			frame:SetAttribute(modifier .. v.action .. button, v.actiontext)
		else
			frame:SetAttribute(modifier .. "type" .. button, v.action)		
		end
	end
end

function Click2Cast:UnregisterFrame(frame)
	for k,v in pairs(self.db.profile.clickOptions) do
		local button = k:match("(%d+)")
		local modifier = k:gsub("%d", "")
		if modifier == "None-" then
			modifier = ""
		end
		
		frame:SetAttribute(modifier .. "type" .. button, nil)
		frame:SetAttribute(modifier .. v.action .. button, nil)
	end
end
